package controller.listener;

import java.awt.event.MouseEvent;

import javax.swing.event.MouseInputAdapter;

import controller.DrawableObjectProcessing;

import model.drawables.AntiAliasedLine;
import model.drawables.Point;

/**
 * Ein Listener, der AntiAliasedLines durch MouseEvents erzeugt und an ein
 * Objekt, das DrawableObjectProcessing implementiert übergibt.
 * 
 * @author Nicolas Neubauer
 * 
 */
public class AntiAliasedLineListener extends MouseInputAdapter {

	private Point tmp;
	private DrawableObjectProcessing delegate;

	/**
	 * 
	 * @param delegate
	 */
	public AntiAliasedLineListener(DrawableObjectProcessing delegate) {
		this.delegate = delegate;
	}

	/**
	 * Merke die aktuelle Koordinate des Startpunktes oder, sofern schon
	 * vorhanden, erzeuge mit Hilfe des neuen (End-)punkts eine neue
	 * AntiAliasedLine und übergebe sie dem Delegate.
	 * 
	 * @param e
	 */
	public void mouseClicked(MouseEvent e) {

		if (tmp == null)
			tmp = new Point(e.getX(), e.getY());
		else {
			AntiAliasedLine l = new AntiAliasedLine(tmp, new Point(e.getX(), e
					.getY()));
			tmp = null;
			delegate.processDrawableObject(l);
		}

	}

}
