package model.drawables;

import java.awt.Graphics;

/**
 * Klasse, die ein gestricheltes Polygon repr&auml;sentiert.
 * 
 * @author Denis Meyer
 * @author Niels Meyering
 */
public class DashedPolygon extends Polygon {

	/**
	 * Konstruktor zum Erzeugen eines gestrichelten Polygons
	 * 
	 * @param start
	 *            Startpunkt
	 * @param filled
	 *            gefuellt oder nicht
	 */
	public DashedPolygon(Point start, boolean filled) {
		super(start, filled);
	}

	/**
	 * Copy-Konstruktor
	 * 
	 * @param p
	 */
	public DashedPolygon(DashedPolygon p) {
		super(p);
	}

	/**
	 * Paint-Methode
	 * 
	 * @param g
	 *            der Graphikkontext, in den das Objekt gezeichnet werden soll
	 */
	public void paint(Graphics g) {
		Point prev = null;

		// Verbindet einen Punkt mit dem Darauffolgenden
		for (Point p : super.getPoints()) {
			if (prev != null) {
				new DashedLine(prev, p).paint(g);
			}
			prev = p;
		}
	}
}
